/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-01 15:32:38 UTC)
 * on 2013-08-06 at 22:26:50 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.taskqueue.model;

/**
 * Model definition for TaskQueue.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the TaskQueue API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class TaskQueue extends com.google.api.client.json.GenericJson {

  /**
   * ACLs that are applicable to this TaskQueue object.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Acl acl;

  /**
   * Name of the taskqueue.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String id;

  /**
   * The kind of REST object returned, in this case taskqueue.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The number of times we should lease out tasks before giving up on them. If unset we lease them
   * out forever until a worker deletes the task.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer maxLeases;

  /**
   * Statistics for the TaskQueue object in question.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Stats stats;

  /**
   * ACLs that are applicable to this TaskQueue object.
   * @return value or {@code null} for none
   */
  public Acl getAcl() {
    return acl;
  }

  /**
   * ACLs that are applicable to this TaskQueue object.
   * @param acl acl or {@code null} for none
   */
  public TaskQueue setAcl(Acl acl) {
    this.acl = acl;
    return this;
  }

  /**
   * Name of the taskqueue.
   * @return value or {@code null} for none
   */
  public java.lang.String getId() {
    return id;
  }

  /**
   * Name of the taskqueue.
   * @param id id or {@code null} for none
   */
  public TaskQueue setId(java.lang.String id) {
    this.id = id;
    return this;
  }

  /**
   * The kind of REST object returned, in this case taskqueue.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * The kind of REST object returned, in this case taskqueue.
   * @param kind kind or {@code null} for none
   */
  public TaskQueue setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The number of times we should lease out tasks before giving up on them. If unset we lease them
   * out forever until a worker deletes the task.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getMaxLeases() {
    return maxLeases;
  }

  /**
   * The number of times we should lease out tasks before giving up on them. If unset we lease them
   * out forever until a worker deletes the task.
   * @param maxLeases maxLeases or {@code null} for none
   */
  public TaskQueue setMaxLeases(java.lang.Integer maxLeases) {
    this.maxLeases = maxLeases;
    return this;
  }

  /**
   * Statistics for the TaskQueue object in question.
   * @return value or {@code null} for none
   */
  public Stats getStats() {
    return stats;
  }

  /**
   * Statistics for the TaskQueue object in question.
   * @param stats stats or {@code null} for none
   */
  public TaskQueue setStats(Stats stats) {
    this.stats = stats;
    return this;
  }

  @Override
  public TaskQueue set(String fieldName, Object value) {
    return (TaskQueue) super.set(fieldName, value);
  }

  @Override
  public TaskQueue clone() {
    return (TaskQueue) super.clone();
  }

  /**
   * ACLs that are applicable to this TaskQueue object.
   */
  public static final class Acl extends com.google.api.client.json.GenericJson {

    /**
     * Email addresses of users who are "admins" of the TaskQueue. This means they can control the
     * queue, eg set ACLs for the queue.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.util.List<java.lang.String> adminEmails;

    /**
     * Email addresses of users who can "consume" tasks from the TaskQueue. This means they can
     * Dequeue and Delete tasks from the queue.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.util.List<java.lang.String> consumerEmails;

    /**
     * Email addresses of users who can "produce" tasks into the TaskQueue. This means they can Insert
     * tasks into the queue.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.util.List<java.lang.String> producerEmails;

    /**
     * Email addresses of users who are "admins" of the TaskQueue. This means they can control the
     * queue, eg set ACLs for the queue.
     * @return value or {@code null} for none
     */
    public java.util.List<java.lang.String> getAdminEmails() {
      return adminEmails;
    }

    /**
     * Email addresses of users who are "admins" of the TaskQueue. This means they can control the
     * queue, eg set ACLs for the queue.
     * @param adminEmails adminEmails or {@code null} for none
     */
    public Acl setAdminEmails(java.util.List<java.lang.String> adminEmails) {
      this.adminEmails = adminEmails;
      return this;
    }

    /**
     * Email addresses of users who can "consume" tasks from the TaskQueue. This means they can
     * Dequeue and Delete tasks from the queue.
     * @return value or {@code null} for none
     */
    public java.util.List<java.lang.String> getConsumerEmails() {
      return consumerEmails;
    }

    /**
     * Email addresses of users who can "consume" tasks from the TaskQueue. This means they can
     * Dequeue and Delete tasks from the queue.
     * @param consumerEmails consumerEmails or {@code null} for none
     */
    public Acl setConsumerEmails(java.util.List<java.lang.String> consumerEmails) {
      this.consumerEmails = consumerEmails;
      return this;
    }

    /**
     * Email addresses of users who can "produce" tasks into the TaskQueue. This means they can Insert
     * tasks into the queue.
     * @return value or {@code null} for none
     */
    public java.util.List<java.lang.String> getProducerEmails() {
      return producerEmails;
    }

    /**
     * Email addresses of users who can "produce" tasks into the TaskQueue. This means they can Insert
     * tasks into the queue.
     * @param producerEmails producerEmails or {@code null} for none
     */
    public Acl setProducerEmails(java.util.List<java.lang.String> producerEmails) {
      this.producerEmails = producerEmails;
      return this;
    }

    @Override
    public Acl set(String fieldName, Object value) {
      return (Acl) super.set(fieldName, value);
    }

    @Override
    public Acl clone() {
      return (Acl) super.clone();
    }

  }

  /**
   * Statistics for the TaskQueue object in question.
   */
  public static final class Stats extends com.google.api.client.json.GenericJson {

    /**
     * Number of tasks leased in the last hour.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key @com.google.api.client.json.JsonString
    private java.lang.Long leasedLastHour;

    /**
     * Number of tasks leased in the last minute.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key @com.google.api.client.json.JsonString
    private java.lang.Long leasedLastMinute;

    /**
     * The timestamp (in seconds since the epoch) of the oldest unfinished task.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key @com.google.api.client.json.JsonString
    private java.lang.Long oldestTask;

    /**
     * Number of tasks in the queue.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Integer totalTasks;

    /**
     * Number of tasks leased in the last hour.
     * @return value or {@code null} for none
     */
    public java.lang.Long getLeasedLastHour() {
      return leasedLastHour;
    }

    /**
     * Number of tasks leased in the last hour.
     * @param leasedLastHour leasedLastHour or {@code null} for none
     */
    public Stats setLeasedLastHour(java.lang.Long leasedLastHour) {
      this.leasedLastHour = leasedLastHour;
      return this;
    }

    /**
     * Number of tasks leased in the last minute.
     * @return value or {@code null} for none
     */
    public java.lang.Long getLeasedLastMinute() {
      return leasedLastMinute;
    }

    /**
     * Number of tasks leased in the last minute.
     * @param leasedLastMinute leasedLastMinute or {@code null} for none
     */
    public Stats setLeasedLastMinute(java.lang.Long leasedLastMinute) {
      this.leasedLastMinute = leasedLastMinute;
      return this;
    }

    /**
     * The timestamp (in seconds since the epoch) of the oldest unfinished task.
     * @return value or {@code null} for none
     */
    public java.lang.Long getOldestTask() {
      return oldestTask;
    }

    /**
     * The timestamp (in seconds since the epoch) of the oldest unfinished task.
     * @param oldestTask oldestTask or {@code null} for none
     */
    public Stats setOldestTask(java.lang.Long oldestTask) {
      this.oldestTask = oldestTask;
      return this;
    }

    /**
     * Number of tasks in the queue.
     * @return value or {@code null} for none
     */
    public java.lang.Integer getTotalTasks() {
      return totalTasks;
    }

    /**
     * Number of tasks in the queue.
     * @param totalTasks totalTasks or {@code null} for none
     */
    public Stats setTotalTasks(java.lang.Integer totalTasks) {
      this.totalTasks = totalTasks;
      return this;
    }

    @Override
    public Stats set(String fieldName, Object value) {
      return (Stats) super.set(fieldName, value);
    }

    @Override
    public Stats clone() {
      return (Stats) super.clone();
    }

  }
}
